=== debian/changelog ===
libcudacxx (2.1.1-1) unstable; urgency=medium

  * New upstream release (CUDA 12.2).
  * Refresh patches.

 -- Andreas Beckmann <anbe@debian.org>  Tue, 02 Jul 2024 08:11:06 +0200

libcudacxx (2.1.0-2) unstable; urgency=medium

  * Relax complex<long double> alignment requirement on i386.
  * Cherry-pick cmake version compatibility fix.

 -- Andreas Beckmann <anbe@debian.org>  Wed, 26 Jun 2024 21:24:33 +0200

libcudacxx (2.1.0-1) unstable; urgency=medium

  * New upstream release.
  * Bump Standards-Version to 4.7.0, no changes needed.
  * Refresh patches.

 -- Andreas Beckmann <anbe@debian.org>  Wed, 26 Jun 2024 14:19:30 +0200
